#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_RouteGroupCFG.h"
std::auto_ptr<Fish_RouteGroupCFG> Fish_RouteGroupCFG::msSingleton(nullptr);

int Fish_RouteGroupCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_RouteGroupCFGData* Fish_RouteGroupCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_RouteGroupCFGData>& Fish_RouteGroupCFG::GetMapData()
{
	return mMapData;
}

void Fish_RouteGroupCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_RouteGroupCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_RouteGroupCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mGroupName = element->Attribute("GroupName");
		{
			const char* RouteIDs = element->Attribute("RouteIDs");
			std::vector<std::string> vecRouteIDs;
			boost::split(vecRouteIDs, RouteIDs, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRouteIDs.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRouteIDs[i].c_str(), &temp))
				{
					data.mRouteIDs.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_RouteGroupCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_RouteGroupCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_RouteGroupCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_RouteGroupCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_RouteGroupCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readString(L, "GroupName", data.mGroupName);
		LuaCfgHelper::readVectorInt(L, "RouteIDs", data.mRouteIDs);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_RouteGroupCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_RouteGroupCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_RouteGroupCFG* Fish_RouteGroupCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_RouteGroupCFG());
	}
	return msSingleton.get();
}

void Fish_RouteGroupCFG::Release()
{
	msSingleton.reset(nullptr);
}
